Index: trunk/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-kernel/zoo_service_loader.c	(revision 8)
+++ trunk/zoo-kernel/zoo_service_loader.c	(revision 9)
@@ -1506,23 +1637,21 @@
        * process answer to http client.
        */
-      char tmp1[256];
       r_inputs=getMapFromMaps(m,"main","tmpPath");
-      sprintf(tmp1,"%s",r_inputs->value);
-      r_inputs=getMap(s1->content,"ServiceProvider");
-      sprintf(tmp1,"%s/%s",strdup(tmp1),r_inputs->value);
-      sprintf(tmp1,"%s_%d.xml",strdup(tmp1),cpid);
+      map* r_inputs1=getMap(s1->content,"ServiceProvider");
+      char* fbkp=(char*)malloc((strlen(r_inputs->value)+strlen(r_inputs1->value)+16)*sizeof(char));
+      sprintf(fbkp,"%s/%s_%d.xml",r_inputs->value,r_inputs1->value,cpid);
+      char* flog=(char*)malloc((strlen(r_inputs->value)+strlen(r_inputs1->value)+22)*sizeof(char));
+      sprintf(flog,"%s/%s_%d_error.log",r_inputs->value,r_inputs1->value,cpid);
+      fprintf(stderr,"File to use as backup %s\n",fbkp);
 #ifdef DEBUG
       fprintf(stderr,"RUN IN BACKGROUND MODE \n");
       fprintf(stderr,"son pid continue (origin %d) %d ...\n",cpid,getpid());
-      fprintf(stderr,"\nFILE TO STORE DATA %s\n",tmp1);
-#endif
-      freopen(tmp1 , "w+", stdout);
+      fprintf(stderr,"\nFILE TO STORE DATA %s\n",r_inputs->value);
+#endif
+      freopen(fbkp , "w+", stdout);
       fclose(stdin);
-      r_inputs=getMapFromMaps(m,"main","tmpPath");
-      sprintf(tmp1,"%s",r_inputs->value);
-      r_inputs=getMap(s1->content,"ServiceProvider");
-      sprintf(tmp1,"%s/%s",strdup(tmp1),r_inputs->value);
-      sprintf(tmp1,"%s_%d_error.log",strdup(tmp1),cpid);
-      freopen(tmp1,"w+",stderr);
+      freopen(flog,"w+",stderr);
+      free(fbkp);
+      free(flog);
       /**
        * set status to SERVICE_STARTED and flush stdout to ensure full 
@@ -1531,6 +1660,6 @@
        * this way the data will be updated at the end of the process run.
        */
-      printProcessResponse1(m,request_inputs,cpid,
-			    s[0],r_inputs->value,SERVICE_STARTED,
+      printProcessResponse(m,request_inputs,cpid,
+			    s1,r_inputs->value,SERVICE_STARTED,
 			    request_input_real_format,
 			    request_output_real_format);
@@ -1546,9 +1675,16 @@
 #endif
 
-      if(strncmp(mtoupper(r_inputs->value),"C",1)==0){
+      if(strncasecmp(r_inputs->value,"C",1)==0){
+
 	r_inputs=getMap(request_inputs,"metapath");
-	sprintf(tmps1,"%s/%s",ntmp,r_inputs->value);
-	r_inputs=getMap(s1->content,"ServiceProvider");
-	sprintf(tmps1,"%s/%s",strdup(tmps1),r_inputs->value);
+	if(r_inputs!=NULL){
+	  sprintf(tmps1,"%s/%s",ntmp,r_inputs->value);
+	  r_inputs=getMap(s1->content,"ServiceProvider");
+	  if(r_inputs!=NULL)
+	    sprintf(tmps1,"%s/%s",strdup(tmps1),r_inputs->value);
+	}else{
+	  sprintf(tmps1,"%s/",ntmp);
+	}
+	  
   
 #ifdef DEBUG
@@ -1556,14 +1692,14 @@
 #endif
 #ifdef WIN32
-	  HINSTANCE so = LoadLibraryEx(tmps1,NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
+	HINSTANCE so = LoadLibraryEx(tmps1,NULL,LOAD_WITH_ALTERED_SEARCH_PATH);
 #else
-      void* so = dlopen(tmps1, RTLD_LAZY);
+	void* so = dlopen(tmps1, RTLD_LAZY);
 #endif
 #ifdef WIN32
-	  DWORD errstr;
-	  errstr = GetLastError();
+	DWORD errstr;
+	errstr = GetLastError();
 #else
-	  char *errstr;
-	  errstr = dlerror();
+	char *errstr;
+	errstr = dlerror();
 #endif
 	if( so != NULL ) {
@@ -1572,5 +1708,5 @@
 	  fprintf(stderr,"r_inputs->value = %s\n",r_inputs->value);
 #endif
-	  if(strcmp(mtoupper(r_inputs->value),"C-FORTRAN")==0){
+	  if(strncasecmp(r_inputs->value,"C-FORTRAN",9)==0){
 	    r_inputs=getMap(request_inputs,"Identifier");
 #ifdef DEBUG
@@ -1584,13 +1720,13 @@
 #endif
 #ifdef WIN32
-	  execute_t execute=(execute_t)GetProcAddress(so,fname); 
+	    execute_t execute=(execute_t)GetProcAddress(so,fname); 
 #else
-	  execute_t execute=(execute_t)dlsym(so,fname);
+	    execute_t execute=(execute_t)dlsym(so,fname);
 #endif
 #ifdef DEBUG
 #ifdef WIN32
-	  errstr = GetLastError();
+	    errstr = GetLastError();
 #else
-	  errstr = dlerror();
+	    errstr = dlerror();
 #endif
 #endif	
@@ -1622,13 +1758,13 @@
 #endif
 #ifdef WIN32
-	  execute_t execute=(execute_t)GetProcAddress(so,r_inputs->value); 
+	    execute_t execute=(execute_t)GetProcAddress(so,r_inputs->value); 
 #else
-	  execute_t execute=(execute_t)dlsym(so,r_inputs->value);
+	    execute_t execute=(execute_t)dlsym(so,r_inputs->value);
 #endif
 #ifdef DEBUG
 #ifdef WIN32
-	  errstr = GetLastError();
+	    errstr = GetLastError();
 #else
-	  errstr = dlerror();
+	    errstr = dlerror();
 #endif
 	    fprintf(stderr,"Function loaded %s\n",errstr);
@@ -1638,6 +1774,6 @@
 	     */
 	    eres=execute(&m,&request_input_real_format,&request_output_real_format);
-	    dlclose(so);
 	  }
+	  dlclose(so);
 	} else {
 	  /**
@@ -1648,39 +1784,41 @@
 	  map* tmps=createMap("text",tmps1);
 	  printExceptionReportResponse(m,tmps);
+	  freeMap(&tmps);
+	  free(tmps);
 	  exit(1);
 	}
       } else{
-	if(strcmp(mtoupper(r_inputs->value),"PYTHON")==0){
+	if(strncasecmp(r_inputs->value,"PYTHON",6)==0){
 	  eres=zoo_python_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
 	}
 	else
 
-	#ifdef USE_JAVA
-	  if(strcmp(mtoupper(r_inputs->value),"JAVA")==0){
+#ifdef USE_JAVA
+	  if(strncasecmp(r_inputs->value,"JAVA",4)==0){
 	    eres=zoo_java_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
 	  }
 	  else
-	#endif
-	
-	#ifdef USE_PHP
-	    if(strcmp(mtoupper(r_inputs->value),"PHP")==0){
+#endif
+	    
+#ifdef USE_PHP
+	    if(strncasecmp(r_inputs->value,"PHP",3)==0){
 	      eres=zoo_php_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
 	    }
 	    else
-	#endif
-
-	#ifdef USE_JS
-	    if(strcmp(mtoupper(r_inputs->value),"JS")==0){
+#endif
+	      
+#ifdef USE_JS
+	      if(strncasecmp(r_inputs->value,"JS",2)==0){
 		eres=zoo_js_support(&m,request_inputs,s1,&request_input_real_format,&request_output_real_format);
 	      }
-	    else
-	#endif
-	{
-	      char tmpv[1024];
-	      sprintf(tmpv,"Programming Language (%s) set in ZCFG file is not currently supported by ZOO Kernel.\n",r_inputs->value);
-	      map* tmps=createMap("text",tmpv);
-	      printExceptionReportResponse(m,tmps);
-	      return -1;
-	    }
+	      else
+#endif
+		{
+		  char tmpv[1024];
+		  sprintf(tmpv,"Programming Language (%s) set in ZCFG file is not currently supported by ZOO Kernel.\n",r_inputs->value);
+		  map* tmps=createMap("text",tmpv);
+		  printExceptionReportResponse(m,tmps);
+		  return -1;
+		}
       }
   
@@ -1697,9 +1835,32 @@
 #ifdef DEBUG
   dumpMaps(request_output_real_format);
-#endif
-  outputResponse(s1,request_input_real_format,
-		 request_output_real_format,request_inputs,
-		 cpid,m,eres);
-
+  fprintf(stderr,"Function loaded and returned %d\n",eres);
+  fflush(stderr);
+#endif
+  if(eres!=-1)
+    outputResponse(s1,request_input_real_format,
+		   request_output_real_format,request_inputs,
+		   cpid,m,eres);
+
+  //if(getpid()==cpid){
+  freeService(&s1);
+  free(s1);
+  freeMaps(&m);
+  free(m);
+  freeMaps(&tmpmaps);
+  free(tmpmaps);
+  
+  freeMaps(&request_input_real_format);
+  free(request_input_real_format);
+  
+  //freeMap(&request_inputs);
+  //free(request_inputs);
+    
+  /* The following is requested but get issue using with Python support :/ */
+  freeMaps(&request_output_real_format);
+  free(request_output_real_format);
+  
+  free(REQUEST);
+  free(SERVICE_URL);
 #ifdef DEBUG
   fprintf(stderr,"Processed response \n");
@@ -1707,4 +1868,5 @@
   fflush(stderr);
 #endif
+    //}
 
   return 0;
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BoundaryPy.zcfg	(revision 9)
@@ -0,0 +1,57 @@
+[BoundaryPy]
+ Title = Compute boundary.
+ Abstract = A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked. 
+ processVersion = 1
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData>
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputPolygon]
+   Title = Polygon to conpute boundary
+   Abstract = URI to a set of GML that describes the polygon.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = application/json
+     encoding = UTF-8
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The geometry created
+   Abstract = The geometry containing the boundary of the geometry on which the method is invoked.
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = application/json
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     asReference = true	
+    </Supported>
+   </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/BufferPy.zcfg	(revision 9)
@@ -0,0 +1,69 @@
+[BufferPy]
+ Title = Create a buffer around a polygon. 
+ Abstract = Create a buffer around a single polygon. Accepts the polygon as GML and provides GML output for the buffered feature. 
+ Profile = urn:ogc:wps:1.0.0:buffer
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData lang="en">
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputPolygon]
+   Title = Polygon to be buffered
+   Abstract = URI to a set of GML that describes the polygon.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     asReference = true	
+    </Default>
+    <Supported>
+     mimeType = aplication/json
+     encoding = UTF-8
+    </Supported>
+   </ComplexData>
+  [BufferDistance]
+   Title = Buffer Distance
+   Abstract = Distance to be used to calculate buffer.
+   minOccurs = 0
+   maxOccurs = 1
+   <LiteralData>
+    DataType = float
+    <Default>
+     uom = meters
+     value = 1
+    </Default>
+    <Supported>
+     uom = feet
+    </Supported>
+   </LiteralData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = Buffered Polygon
+   Abstract = GML stream describing the buffered polygon feature.
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = application/json
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     asReference = true	
+    </Supported>
+   </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/CentroidPy.zcfg	(revision 9)
@@ -0,0 +1,54 @@
+[CentroidPy]
+ Title = Get the centroid of a polygon. 
+ Abstract = Compute the geometry centroid.
+ Profile = urn:ogc:wps:1.0.0:centroid
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData lang="en">
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputPolygon]
+   Title = Polygon to get the centroid
+   Abstract = The centroid which is not necessarily within the geometry.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The Centroid
+   Abstract = JSON String / GML Entity of the centroid
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = application/json
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/point.xsd
+     asReference = true	
+    </Supported>
+   </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ConvexHullPy.zcfg	(revision 9)
@@ -0,0 +1,51 @@
+[ConvexHullPy]
+ Title = Compute convex hull.
+ Abstract = A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.
+ processVersion = 1
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData lang="en">
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputPolygon]
+   Title = Polygon to compute convexhull
+   Abstract = URI to a set of GML that describes the polygon.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+   title = Mon test
+   </MetaData>
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = application/json
+     encoding = UTF-8
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The convex hull of the geometry
+   Abstract = The convex hull of the geometry
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = application/json
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+ </DataOutputs> 
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/DifferencePy.zcfg	(revision 9)
@@ -0,0 +1,75 @@
+[DifferencePy]
+ Title = Compute difference. . 
+ Abstract = Generates a new geometry which is the region of this geometry with the region of the other geometry removed.
+ Profile = urn:ogc:wps:1.0.0:difference
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData>
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputEntity1]
+   Title = the first geometry 
+   Abstract = the first geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+  [InputEntity2]
+   Title = the other geometry
+   Abstract = the other geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The difference between two geometries
+   Abstract = The difference between the two geometries.
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+    <ComplexData>
+     <Default>
+       mimeType = application/json
+       encoding = UTF-8
+       extension = js
+     </Default>
+     <Supported>
+      mimeType = text/xml
+      schema = http://fooa/gml/3.1.0/polygon.xsd
+      encoding = UTF-8
+      extension = xml
+     </Supported>
+    </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/IntersectionPy.zcfg	(revision 9)
@@ -0,0 +1,75 @@
+[IntersectionPy]
+ Title = Compute intersection. 
+ Abstract = Generates a new geometry which is the region of intersection of the two geometries operated on.
+ Profile = urn:ogc:wps:1.0.0:union
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData>
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputEntity1]
+   Title = the first geometry 
+   Abstract = the first geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+  [InputEntity2]
+   Title = the other geometry
+   Abstract = the other geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = Intersection of the two geometries
+   Abstract = A new geometry representing the intersection or NULL if there is no intersection or an error occurs.
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+    <ComplexData>
+     <Default>
+       mimeType = application/json
+       encoding = UTF-8
+       extension = js
+     </Default>
+     <Supported>
+      mimeType = text/xml
+      schema = http://fooa/gml/3.1.0/polygon.xsd
+      encoding = UTF-8
+      extension = xml
+     </Supported>
+    </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/SymDifferencePy.zcfg	(revision 9)
@@ -0,0 +1,75 @@
+[SymDifferencePy]
+ Title = Compute symmetric difference. 
+ Abstract = Generates a new geometry which is the symmetric difference of this geometry and the other geometry.
+ Profile = urn:ogc:wps:1.0.0:symmetricdifference
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData>
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputEntity1]
+   Title = the first geometry 
+   Abstract = the first geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+  [InputEntity2]
+   Title = the other geometry
+   Abstract = the other geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = text/xml
+     encoding = base64
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The symmetric difference between two geometries
+   Abstract = The symmetric difference between the two geometries.
+   <MetaData lang="en">
+    Title = Symmetric Difference  
+   </MetaData>   
+    <ComplexData>
+     <Default>
+       mimeType = application/json
+       encoding = UTF-8
+       extension = js
+     </Default>
+     <Supported>
+      mimeType = text/xml
+      schema = http://fooa/gml/3.1.0/polygon.xsd
+      encoding = UTF-8
+      extension = xml
+     </Supported>
+    </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/UnionPy.zcfg	(revision 9)
@@ -0,0 +1,73 @@
+[UnionPy]
+ Title = Compute union. 
+ Abstract = Generates a new geometry which is the region of union of the two geometries operated on.
+ Profile = urn:ogc:wps:1.0.0:union
+ processVersion = 2
+ storeSupported = true
+ statusSupported = true
+ serviceProvider = ogr_sp
+ serviceType = Python
+ <MetaData>
+   title = Demo
+ </MetaData>
+ <DataInputs>
+  [InputEntity1]
+   Title = the first geometry 
+   Abstract = the first geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+    </Default>
+    <Supported>
+     mimeType = application/json
+     encoding = UTF-8
+    </Supported>
+   </ComplexData>
+  [InputEntity2]
+   Title = the other geometry
+   Abstract = the other geometry to compare against.
+   minOccurs = 1
+   maxOccurs = 1
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+   <ComplexData>
+    <Default>
+     mimeType = text/xml
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     encoding = UTF-8
+    </Default>
+    <Supported>
+     mimeType = application/json
+     encoding = UTF-8
+    </Supported>
+   </ComplexData>
+ </DataInputs>
+ <DataOutputs>
+  [Result]
+   Title = The union of two geometries
+   Abstract = The geometry representing the union of the two geometries.
+   <MetaData lang="en">
+    title = Mon test  
+   </MetaData>   
+    <ComplexData>
+     <Default>
+       mimeType = application/json
+       encoding = UTF-8
+       extension = js
+     </Default>
+     <Supported>
+      mimeType = text/xml
+      schema = http://fooa/gml/3.1.0/polygon.xsd
+      encoding = UTF-8
+      extension = xml
+     </Supported>
+    </ComplexData>
+ </DataOutputs>  
Index: trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ogr_sp.py
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ogr_sp.py	(revision 9)
+++ trunk/zoo-services/ogr/base-vect-ops-py/cgi-env/ogr_sp.py	(revision 9)
@@ -0,0 +1,95 @@
+import osgeo.ogr
+import libxml2
+
+def createGeometryFromWFS(my_wfs_response):
+    doc=libxml2.parseMemory(my_wfs_response,len(my_wfs_response))
+    ctxt = doc.xpathNewContext()
+    res=ctxt.xpathEval("/*/*/*/*/*[local-name()='Polygon' or local-name()='MultiPolygon']")
+    for node in res:
+        geometry_as_string=node.serialize()
+        geometry=osgeo.ogr.CreateGeometryFromGML(geometry_as_string)
+	return geometry
+    return geometry
+
+def extractInputs(obj):
+    if obj["mimeType"]=="application/json":
+	return osgeo.ogr.CreateGeometryFromJson(obj["value"])
+    else:
+	try:
+        	return createGeometryFromWFS(obj["value"])
+	except:
+		return osgeo.ogr.CreateGeometryFromJson(obj["value"])
+    return null
+    
+def outputResult(obj,geom):
+    if obj["mimeType"]=="application/json":
+        obj["value"]=geom.ExportToJson()
+        obj["mimeType"]="text/plain"
+    else:
+        obj["value"]=geom.ExportToGML()
+
+def BoundaryPy(conf,inputs,outputs):
+    geometry=extractInputs(inputs["InputPolygon"])
+    rgeom=geometry.GetBoundary()
+    if outputs["Result"]["mimeType"]=="application/json":
+        outputs["Result"]["value"]=rgeom.ExportToJson()
+        outputs["Result"]["mimeType"]="text/plain"
+    else:
+        outputs["Result"]["value"]=rgeom.ExportToGML()
+    return 3
+
+def CentroidPy(conf,inputs,outputs):
+    geometry=extractInputs(inputs["InputPolygon"])
+    if geometry.GetGeometryType()!=3:
+        geometry=geometry.ConvexHull()
+    rgeom=geometry.Centroid()
+    outputResult(outputs["Result"],rgeom)
+    return 3
+
+def ConvexHullPy(conf,inputs,outputs):
+    geometry=extractInputs(inputs["InputPolygon"])
+    rgeom=geometry.ConvexHull()
+    outputResult(outputs["Result"],rgeom)
+    return 3
+
+def BufferPy(conf,inputs,outputs):
+    geometry=createGeometryFromWFS(inputs["InputPolygon"]["value"])
+    try:
+        bdist=int(inputs["BufferDistance"]["value"])
+    except:
+        bdist=10
+    rgeom=geometry.Buffer(bdist)
+    if outputs["Result"]["mimeType"]=="application/json":
+        outputs["Result"]["value"]=rgeom.ExportToJson()
+        outputs["Result"]["mimeType"]="text/plain"
+    else:
+        outputs["Result"]["value"]=rgeom.ExportToGML()
+    return 3
+
+def UnionPy(conf,inputs,outputs):
+    geometry1=extractInputs(inputs["InputEntity1"])
+    geometry2=extractInputs(inputs["InputEntity2"])
+    rgeom=geometry1.Union(geometry2)
+    outputResult(outputs["Result"],rgeom)
+    return 3
+
+def IntersectionPy(conf,inputs,outputs):
+    geometry1=extractInputs(inputs["InputEntity1"])
+    geometry2=extractInputs(inputs["InputEntity2"])
+    rgeom=geometry1.Intersection(geometry2)
+    outputResult(outputs["Result"],rgeom)
+    return 3
+
+def DifferencePy(conf,inputs,outputs):
+    geometry1=extractInputs(inputs["InputEntity1"])
+    geometry2=extractInputs(inputs["InputEntity2"])
+    rgeom=geometry1.Difference(geometry2)
+    outputResult(outputs["Result"],rgeom)
+    return 3
+
+def SymDifferencePy(conf,inputs,outputs):
+    geometry1=extractInputs(inputs["InputEntity1"])
+    geometry2=extractInputs(inputs["InputEntity2"])
+    rgeom=geometry1.SymmetricDifference(geometry2)
+    outputResult(outputs["Result"],rgeom)
+    return 3
Index: trunk/zoo-services/ogr/base-vect-ops/Makefile
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/Makefile	(revision 8)
+++ trunk/zoo-services/ogr/base-vect-ops/Makefile	(revision 9)
@@ -1,7 +1,7 @@
-CFLAGS=-I../../zoo-kernel/ -I./ `xml2-config --cflags` `python-config --cflags`  `gdal-config --cflags`   -DLINUX_FREE_ISSUE #-DDEBUG
+CFLAGS=-I../../../zoo-kernel/ -I./ `xml2-config --cflags` `python-config --cflags`  `gdal-config --cflags`   -DLINUX_FREE_ISSUE #-DDEBUG
 CC=gcc
 
 cgi-env/service.zo: service.c
-	g++ ${CFLAGS} -shared -fpic -o cgi-env/ogr_service.zo ./service.c `gdal-config --libs`
+	g++ ${CFLAGS} -shared -fpic -o cgi-env/ogr_service.zo ./service.c ../../../zoo-kernel/service_internal.o `gdal-config --libs`
 
 clean:
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 8)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 9)
@@ -8,19 +8,20 @@
  serviceType = C
  <MetaData>
-   Test = Demo
+   title = Demo
  </MetaData>
  <DataInputs>
   [InputPolygon]
-   Title = Polygon to be buffered
+   Title = Polygon to compute boundary
    Abstract = URI to a set of GML that describes the polygon.
    minOccurs = 1
    maxOccurs = 1
    <MetaData lang="en">
-    Test = Mon test  
+    title = Mon test  
    </MetaData>   
    <ComplexData>
     <Default>
-     mimeType = text/js
+     mimeType = text/xml
      encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
     </Default>
     <Supported>
@@ -30,41 +31,30 @@
     </Supported>
    </ComplexData>
-  [BufferDistance]
-   Title = Buffer Distance
-   Abstract = Distance to be used to calculate buffer.
-   minOccurs = 0
-   maxOccurs = 1
-   <LiteralData>
-    DataType = float
-    <Default>
-     uom = meters
-    </Default>
-    <Supported>
-     uom = feet
-    </Supported>
-   </LiteralData>
  </DataInputs>
  <DataOutputs>
-  [Boundary]
+  [Result]
    Title = The geometry created
    Abstract = The geometry containing the boundary of the geometry on which the method is invoked.
    <MetaData lang="en">
-    Test1 = Mon test  
+    title = Mon test  
    </MetaData>   
    <ComplexData>
     <Default>
-     mimeType = text/xml
+     mimeType = application/json
      encoding = UTF-8
-     schema = http://fooa/gml/3.1.0/polygon.xsd
+     extension = js
      asReference = true	
     </Default>
     <Supported>
      mimeType = text/xml
+     encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     extension = xml
+    </Supported>
+    <Supported>
+     mimeType = text/xml
      encoding = base64
      schema = http://fooa/gml/3.1.0/polygon.xsd
-    </Supported>
-    <Supported>
-     mimeType = text/js
-     encoding = UTF-8
+     extension = xml
     </Supported>
    </ComplexData>
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg	(revision 8)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg	(revision 9)
@@ -9,5 +9,5 @@
  serviceType = C
  <MetaData lang="en">
-   Test = Demo
+   title = Demo
  </MetaData>
  <DataInputs>
@@ -18,5 +18,5 @@
    maxOccurs = 1
    <MetaData lang="en">
-    Test = Mon test  
+    title = Mon test  
    </MetaData>   
    <ComplexData>
@@ -49,15 +49,15 @@
  </DataInputs>
  <DataOutputs>
-  [BufferedPolygon]
+  [Result]
    Title = Buffered Polygon
    Abstract = GML stream describing the buffered polygon feature.
    <MetaData lang="en">
-    Test1 = Mon test  
+    title = Mon test  
    </MetaData>   
    <ComplexData>
     <Default>
-     mimeType = text/xml
+     mimeType = application/json
      encoding = UTF-8
-     schema = http://fooa/gml/3.1.0/polygon.xsd
+     extension = js
      asReference = true	
     </Default>
@@ -66,8 +66,11 @@
      encoding = base64
      schema = http://fooa/gml/3.1.0/polygon.xsd
+     extension = xml
     </Supported>
     <Supported>
-     mimeType = application/json
+     mimeType = text/xml
      encoding = UTF-8
+     schema = http://fooa/gml/3.1.0/polygon.xsd
+     extension = xml
     </Supported>
    </ComplexData>
